/* $Id: util.c,v 1.14 2007-01-22 21:38:18 kristaps Exp $ */
/*
Copyright (c) 2006 Kristaps Dzonsons
Latvijas Universitaates Matemaatikas un Informaatikas Instituuts
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.
* Neither the name of the copyright holders nor the names of
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <sys/param.h>
#include <sys/time.h>

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>

#include "pl_mpi.h"


#define DBG_BUFSZ 4096
static char buf[DBG_BUFSZ];

void
mpidbg(const char *file, int line, const char *fmt, ...)
{
	va_list ap;
	char *p;
	assert(file != NULL);
	if (opts.trace == NULL)
		return;
	p = buf;
	p += snprintf(buf, DBG_BUFSZ, "# %s.%d: ", 
			file, line);
	va_start(ap, fmt);
	(void)vsprintf(p, fmt, ap);
	va_end(ap);
	(void)fprintf(opts.trace, "%s\n", buf);
	(void)fflush(opts.trace);
}

void
mpitrace(const char *fmt, ...)
{
	va_list ap;
	char *p;
	if (opts.trace == NULL)
		return;
	p = buf;
	va_start(ap, fmt);
	(void)vsprintf(p, fmt, ap);
	va_end(ap);
	(void)fprintf(opts.trace, "%s\n", buf);
	(void)fflush(opts.trace);
}
